// usage: ./a.out input_file correct_output output_dir < contestants_output
// See specification there:
// http://www.problemarchive.org/wiki/index.php/Output_validator

#include <iostream>
#include <unordered_set>
#include <vector>
#include <set>
#include <sstream>
#include "validate.h"

int N, K;

std::multiset<int> weights;

int check_line(std::istream& input) {
  std::string line;
  std::getline(input, line);
  std::istringstream iss(line);
  int sum;
  if (!(iss >> sum)) {
    wrong_answer("missing sum\n");
  }
  char c;
  do {
    iss.get(c);
  } while (c == ' ');
  if (c != ':') {
    wrong_answer("unexpected char\n");
  }
  std::multiset<int> answer_weights;
  int w;
  int actual_sum = 0;
  while(true) {
    if (!(iss >> w)) {
      break;
    }
    actual_sum += w;
    if (weights.count(w) == 0) {
      wrong_answer("Used invalid weight\n");
    }
    answer_weights.insert(w);
    if (answer_weights.count(w) > weights.count(w)) {
      wrong_answer("Used weight too many times\n");
    }
  }
  if (actual_sum != sum) {
    wrong_answer("Weights don't have the right sum\n");
  }
  return sum;
}

int main(int argc, char **argv) {
  init_io(argc, argv);

  judge_in >> N >> K;
  for (int i = 0; i < N; i++) {
    int w;
    judge_in >> w;
    weights.insert(w);
  }
  for (int i = 0; i < K; ++i) {
    if (check_line(judge_ans) != check_line(author_out)) {
      wrong_answer("wrong sum\n");
    }
  }

  accept();
}
