// O(N^2*K + N*K*log(K)) solution. But in practice the N^2 part is
// very pessimistic (TODO: think about hard test cases or improve the
// bound).

#include <algorithm>
#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

struct Candidate {
  int sum;
  vector<int> weights;
  bool operator<(const Candidate &c) {
    // Ignore the weights.
    return sum < c.sum;
  }
  bool operator==(const Candidate &c) { return sum == c.sum; }
};

int main() {
  int N, K;
  cin >> N >> K;
  vector<int> weights(N);
  for (int i = 0; i < N; ++i) {
    cin >> weights[i];
  }

  vector<Candidate> possible = {{0, vector<int>()}};

  for (int w : weights) {
    int sz_before = possible.size();
    for (int i = 0; i < sz_before; ++i) {
      vector<int> new_weights(possible[i].weights);
      new_weights.push_back(w);
      possible.push_back({possible[i].sum + w, new_weights});
    }
    std::sort(possible.begin(), possible.end());
    possible.erase(std::unique(possible.begin(), possible.end()),
                   possible.end());
    if (possible.size() > K) {
      possible.erase(possible.begin() + K, possible.end());
    }
  }
  assert(possible.size() == K);
  for (const Candidate &candidate : possible) {
    cout << candidate.sum << ": ";
    for (int w : candidate.weights) {
      cout << w << " ";
    }
    cout << endl;
  }
}
