// O(N*K*log(K)) solution using hash maps.

#include <algorithm>
#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

int main() {
  int N, K;
  cin >> N >> K;
  vector<int> weights(N);
  for (int i = 0; i < N; ++i) {
    cin >> weights[i];
  }

  unordered_map<int, int> last_element;
  vector<int> possible = {0};
  
  for (int w : weights) {
    int sz_before = possible.size();
    for (int i = 0; i < sz_before; ++i) {
      int new_sum = possible[i] + w;
      possible.push_back(new_sum);
      last_element.emplace(new_sum, w);
    }
    std::sort(possible.begin(), possible.end());
    possible.erase(std::unique(possible.begin(), possible.end()),
		   possible.end());
    if (possible.size() > K) {
      possible.erase(possible.begin() + K, possible.end());
    }
  }
  for (int candidate : possible) {
    cout << candidate << ": ";
    int remaining = candidate;
    while (remaining > 0) {
      int w = last_element.at(remaining);
      cout << w << " ";
      remaining -= w;
    }
    cout << endl;
  }
}
