// O(N*K*log(K) + N log(N)) solution using hash maps.

#include <algorithm>
#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

int main() {
  int N, K;
  cin >> N >> K;
  vector<int> weights(N);
  for (int i = 0; i < N; ++i) {
    cin >> weights[i];
  }
  std::sort(weights.begin(), weights.end());
  unordered_map<int, int> last_element;
  vector<int> possible = {0};

  int skip_larger_than = 1<<30;
  int sorted_end_index = possible.size();
  for (int w : weights) {
    int sz_before = possible.size();
    for (int i = 0; i < sz_before; ++i) {
      int new_sum = possible[i] + w;
      if (new_sum > skip_larger_than) {
	continue;
      }
      if (binary_search(possible.begin(), possible.begin() + sorted_end_index, new_sum)) {
	continue;
      }
      possible.push_back(new_sum);
      last_element.emplace(new_sum, w);
    }
    std::sort(possible.begin(), possible.end());
    possible.erase(std::unique(possible.begin(), possible.end()),
		   possible.end());
    if (possible.size() > K) {
      possible.erase(possible.begin() + K, possible.end());
    }
    if (possible.size() == K) {
      skip_larger_than = possible.back();
    }
    sorted_end_index = possible.size();
  }
  for (int candidate : possible) {
    cout << candidate << ": ";
    int remaining = candidate;
    while (remaining > 0) {
      int w = last_element.at(remaining);
      cout << w << " ";
      remaining -= w;
    }
    cout << endl;
  }
}
