import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Random;

public class VincentRandom {
	private static void findKPos(int[] tab, int k, int start, int end) {
		int left = start;
		int right = end - 1;
		int pivot = tab[right];
		while (left < right) {
			if (tab[left] > pivot) {
				tab[right] = tab[left];
				right--;
				tab[left] = tab[right];
			} else {
				left++;
			}
		}
		tab[left] = pivot;
		if (left == k) {
			return;
		} else if (left < k) {
			findKPos(tab, k, left + 1, end);
		} else {
			findKPos(tab, k, start, left);
		}
	}

	private static long getSum(int[] tab, int n, int k) {
		Random r = new Random();
		for (int i = 0; i < n; i++) {
			int swap = tab[i];
			int j = r.nextInt(n);
			tab[i] = tab[j];
			tab[j] = swap;
		}
		findKPos(tab, k, 0, n);
		long sum = 0;
		for (int i = k; i < n; i++) {
			sum += tab[i];
		}
		return sum;
	}

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String[] line = br.readLine().split(" ");
		int N = Integer.parseInt(line[0]);
		int K = Integer.parseInt(line[1]);
		int[] values = new int[N];
		for (int i = 0; i < N; i++) {
			values[i] = Integer.parseInt(br.readLine());
		}
		br.close();
		long sum = getSum(values, N, N - K);
		System.out.println(sum);
	}
}

