import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.TreeMap;

/* Vincent, with heap */

public class Average {
	private static int N;
	private static int S;
	private static int[] W;
	private static TreeMap<Integer, Integer> count;

	private static void read() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String[] line = br.readLine().split(" ");
		N = Integer.parseInt(line[0]);
		S = Integer.parseInt(line[1]);
		W = new int[N];
		for (int i = 0; i < N; i++) {
			W[i] = Integer.parseInt(br.readLine());
		}
		br.close();
	}

	private static void getHeap() {
		count = new TreeMap<>();
		for (int i = 0; i < N; i++) {
			count.merge(W[i], 1, Integer::sum);
		}
	}

	private static int maxValue() {
		int val = 0;
		int cur = Integer.MIN_VALUE;
		for (int i = 0; i < N; i++) {
			count.compute(W[i], (w, c) -> {
				return c > 1 ? c - 1 : null;
			});
			count.merge(W[i] + N * S, 1, Integer::sum);
			int now = count.navigableKeySet().first() - (i + 1) * S;
			if (now > cur) {
				cur = now;
				val = i + 1;
				//System.out.println(val + ":" + cur);
			}
		}
		return cur;
	}

	public static void main(String[] args) throws IOException {
		read();
		getHeap();
		System.out.println(maxValue());
	}
}
