import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/* Vincent, with dominating sequences */
/* Linear */

public class Fast {

	private static int N;
	private static int S;
	private static int[] W;
	private static int[] D;
	private static int dominators;

	private static void read() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String[] line = br.readLine().split(" ");
		N = Integer.parseInt(line[0]);
		S = Integer.parseInt(line[1]);
		W = new int[N];
		for (int i = 0; i < N; i++) {
			W[i] = Integer.parseInt(br.readLine());
		}
		br.close();
	}

	private static void getDominatingList() {
		D = new int[N + 1]; // reprendre ici !
		dominators = -1;
		for (int i = 0; i < N; i++) {
			while (dominators > -1 && W[i] <= W[D[dominators]]) {
				dominators--;
			}
			dominators++;
			D[dominators] = i;
		}
		while (W[D[dominators]] >= W[D[0]] + N * S) {
			dominators--;
		}
		W[D[0]] += N * S;
		D[dominators + 1] = D[0];
	}

	private static int minValue() {
		int cur = Integer.MIN_VALUE;
		int val = 0;
		for (int i = 0; i <= dominators; i++) {
			int now = W[D[i + 1]] - (D[i] + 1) * S;
			if (cur < now) {
				cur = now;
				val = D[i] + 1;
				//System.out.println(val + ":" + cur);
			}
		}
		return cur;
	}

	public static void main(String[] args) throws IOException {
		read();
		getDominatingList();
		System.out.println(minValue());
	}

}
