#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

/* Ioana, N log N with a heap */

#define MAXN 100000
#define MAXC 100000000000

long long N, S;

struct NodeInfo {
    long long index;
    long long initVal;
};

typedef struct NodeInfo NodeInfo;

NodeInfo H[2*MAXN+2];
long long place[2*MAXN+2];

void swap(long long i, long long j){
     NodeInfo aux = H[i]; H[i]=H[j]; H[j]=aux;
     place[H[i].index] = i;
     place[H[j].index] = j;
}

void down(long i, long N) {
    long long min = i;
    do {
        i = min; 
        if (2*i<=N && H[2*i].initVal<H[min].initVal)
            min = 2*i;
        if (2*i+1<=N && H[2*i+1].initVal<H[min].initVal)
            min = 2*i+1;
        if (min != i) 
            swap(min,i); 
    }  while (i!=min);   
}

void up (long long pos) {
    long long parent;
    parent = pos / 2;
    while (parent >= 1 && H[pos].initVal < H[parent].initVal){
        swap(pos, parent);
        pos = parent;
        parent = pos/2;
    }    
}

void delete (long long pos) {
    H[pos] = H[N];
    place[H[pos].index] = pos;
    N--;
    down(pos,N);
}

void insert(long long index, long long val){
    N++;
    H[N].index = index;
    place[H[N].index] =N;
    H[N].initVal = val;
    up(N);
}

void heapify() {
    long long i;
    for (i = N/2; i>=1; i--)
        down(i,N); 
}

int main()
{
    long long i, best, val, crtbest;
    size_t ret;
    
    ret = scanf("%lld%lld",&N,&S);
    
    memset (H, 0, N*sizeof(long long));

    for (i = 1; i <= N; ++i) {
        ret = scanf("%lld", &H[i].initVal);
        H[i].index = i;
        place[i] = i;
    }
    
    heapify();
 
    best = 0;   
 
    for (i = 1; i <=N; ++i) { 
       val = H[place[i]].initVal;  
       
       delete(place[i]); 
       insert(i,val + S*(N+1));
       crtbest = H[1].initVal - i*S;
              
       if (crtbest > best) 
            best = crtbest;
    }
    
    printf("%lld\n",best);
    (void)ret;
    
    return 0;
}

