#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#define MAXN 5000
#define MAXK 5000
#define MAXS 1000000

long long N,K;

long long S[MAXK+1];
long long P[MAXK+1];

long long min[MAXK+1][MAXN+1];

void swap(int i, int j) {
    long aux = S[j]; S[j] = S[i]; S[i] = aux;
    aux = P[j]; P[j] = P[i]; P[i] = aux;
}

int isg (int i, int j){
    if (S[i]>S[j] || (S[i] == S[j] && P[i]>P[j])) return 1;
    return 0;
}

void down (int i, int n) {
    int min = i;
    do {
        i = min;
        if (2*i<=n && isg(2*i,min))
            min = 2*i;
        if (2*i+1<=n && isg(2*i+1,min))
            min = 2*i+1;
        if (min != i) 
            swap(min,i);    
   }
   while (i!=min);
}

void sort() {
    int i;
    for (i = K/2; i>=1; i--)
        down(i, K); 
             
    for (i = K; i>=2; i--){
        swap(1,i);
        down(1,i-1);
    }
}
   
        
int main()
{
    int i, j;
    long long tmpmin;
    size_t ret;
    
    ret = scanf("%d%d",&N,&K);
    
    for (i = 1; i <= K; ++i) 
        for (j  = 0; j <= N; ++j) 
            min[i][j] = K*N*MAXS+1;
    
    for (i = 1; i <= K; ++i) 
        ret = scanf("%ld%ld", &P[i], &S[i]);
    
    for (j  = 0; j <= N; ++j) 
        min[0][j] = 0;

    sort();
  
    for (i = 1; i <= K; ++i)
        for (j  = 1; j <= N; ++j) {
            tmpmin = min[i-1][j-1] +  S[i]*abs(P[i]-j);
            if (tmpmin < min[i][j]) {
                min[i][j] = tmpmin;
            }
            tmpmin = min[i][j-1];
            if (tmpmin < min[i][j]){
                min[i][j] = tmpmin;
            } 
        }
    printf("%lld\n", min[K][N]);
           
    (void)ret;
    
    return 0;
}

